--[[
Title: 	gHUDPvsT
Author: 	Mahiro/Grognaz Aegwynn(EU)
]]
------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------

--frame dimensions
gHUDPvsT_bar_width = 100
gHUDPvsT_bar_height = 15
---------------------------------------------------------
--pvst hp color ranges
pvst_hp_max_color_value = 1
pvst_hp_med_color_value = 0
pvst_hp_low_color_value = 1
---------------------------------------------------------
--pvst mp color ranges
pvst_mp_max_color_value = 1
pvst_mp_med_color_value = 0
pvst_mp_low_color_value = 1
---------------------------------------------------------
--background color
gHUD_background_color ={
bg_color_r = 0,
bg_color_g = 1,
bg_color_b = 0,
bg_color_a = 0.6,
}
---------------------------------------------------------
--pvst  hp colors
gHUDPvsT_hp_color = {
pvst_hp_color_100_r = 0,
pvst_hp_color_100_g = 1,
pvst_hp_color_100_b = 0,
pvst_hp_color_100_a = 1,

pvst_hp_color_50_r = 1,
pvst_hp_color_50_g = 1,
pvst_hp_color_50_b = 0,
pvst_hp_color_50_a = 1,

pvst_hp_color_00_r = 1,
pvst_hp_color_00_g = 0,
pvst_hp_color_00_b = 0,
pvst_hp_color_00_a = 1,
}
---------------------------------------------------------
--pvst mp colors
gHUDPvsT_mp_color = {
pvst_mp_color_100_r = 0,
pvst_mp_color_100_g = 0,
pvst_mp_color_100_b = 1,
pvst_mp_color_100_a = 1,

pvst_mp_color_50_r = 1,
pvst_mp_color_50_g = 1,
pvst_mp_color_50_b = 1,
pvst_mp_color_50_a = 1,

pvst_mp_color_00_r = 1,
pvst_mp_color_00_g = 0,
pvst_mp_color_00_b = 0,
pvst_mp_color_00_a = 1,
}
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
--OnLoad
function gHUDPvsT_OnLoad()

--Slash Commands	
	SLASH_gHUDPvsT1 = "/playervstarget"
	SLASH_gHUDPvsT2 = "/pvst"
	SlashCmdList["gHUDPvsT"] = gHUDPvsT_Command
---------------------------------------------------------
--Handlers
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("PLAYER_TARGET_CHANGED") 
	this:RegisterEvent("PLAYER_REGEN_ENABLED")
	this:RegisterEvent("PLAYER_REGEN_DISABLED")
	
	this:RegisterEvent("UNIT_HEALTH")
	this:RegisterEvent("UNIT_MANA")

	--DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00gHUD: |cFFFF0000Loaded")

end

---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
--load OnEvent
function gHUDPvsT_Load_OnEvent()
--show/hide target frames
	if (event=="ADDON_LOADED") and (arg1=="gHUDPvsT") then
		if (UnitExists("target")) then
			gHUDPvsT_HP_FRAME:Show()
			gHUDPvsT_MP_FRAME:Show()
		else
			gHUDPvsT_HP_FRAME:Hide()
			gHUDPvsT_MP_FRAME:Hide()
		end
	end
---------------------------------------------------------
	if (event=="ADDON_LOADED") then
		if (options.posX==nil) 
		and (options.posY==nil) then
			gHUDPvsT_HP_FRAME:ClearAllPoints()
			gHUDPvsT_HP_FRAME:SetPoint("CENTER", nil)
			options.posX = gHUDPvsT_HP_FRAME:GetBottom()
			options.posY = gHUDPvsT_HP_FRAME:GetLeft()
		else	
			gHUDPvsT_HP_FRAME:ClearAllPoints()
			gHUDPvsT_HP_FRAME:SetPoint("BOTTOMLEFT", nil, "BOTTOMLEFT", options.posX, options.posY)
			
			options.posX = gHUDPvsT_HP_FRAME:GetLeft()
			options.posY = gHUDPvsT_HP_FRAME:GetBottom()
		end
	end
end
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
--change OnEvent
function gHUDPvsT_Change_OnEvent()
--show/hide target frames
	if (event=="PLAYER_TARGET_CHANGED") then
		if (UnitExists("target")) then
			gHUDPvsT_HP_FRAME:Show()
			gHUDPvsT_MP_FRAME:Show()
		else
			gHUDPvsT_HP_FRAME:Hide()
			gHUDPvsT_MP_FRAME:Hide()
		end
	end
end
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
function gHUDPvsT_textures()
	--textures
	gHUD_TEXTURE_B_h = "Interface\\AddOns\\gHUDPvsT\\texture\\bar_h"
	gHUD_TEXTURE_BG_h = "Interface\\AddOns\\gHUDPvsT\\texture\\bg_h"
	gHUD_TEXTURE_B_w = "Interface\\AddOns\\gHUDPvsT\\texture\\bar_w"
	gHUD_TEXTURE_BG_w = "Interface\\AddOns\\gHUDPvsT\\texture\\bg_w"
end
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------

function gHUDPvsT_deficit_values()
	--deficit values
	hpdp =  (1-(UnitHealth("player")/UnitHealthMax("player")))
	hpdt = (1-(UnitHealth("target")/UnitHealthMax("target")))
	mpdp = (1-(UnitMana("player")/UnitManaMax("player")))
	mpdt = (1-(UnitMana("target")/UnitManaMax("target")))
end
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
--playervstarget HP
function gHUDPvsT_HP_OnEvent()
	--texture
	gHUDPvsT_textures()

	gHUDPvsT_BAR_TEXTURE_W_HP:SetTexture(gHUD_TEXTURE_B_w)
	gHUDPvsT_BACKGROUND_TEXTURE_W_HP:SetTexture(gHUD_TEXTURE_BG_w)

	gHUDPvsT_HP_BAR:SetHeight(gHUDPvsT_bar_height)
	gHUDPvsT_HP_FRAME:SetHeight(gHUDPvsT_bar_height)

	gHUDPvsT_HP_FRAME:SetWidth(gHUDPvsT_bar_width*2)
	---------------------------------------------------------
	--deficit value function
	gHUDPvsT_deficit_values()
	---------------------------------------------------------
	--hp pvst
	-- target advantage
	if UnitIsVisible("target")==1 then
	if hpdp>hpdt 
		then gHUDPvsT_bar_width_hpdt = (hpdp-hpdt)*gHUDPvsT_bar_width
				--target hp offset
				gHUDPvsT_HP_BAR:ClearAllPoints()
				gHUDPvsT_HP_BAR:SetPoint("LEFT", "gHUDPvsT_HP_FRAME", "CENTER", -gHUDPvsT_bar_width_hpdt, 0)
				gHUDPvsT_HP_BAR:SetWidth(gHUDPvsT_bar_width_hpdt)
	end
	---------------------------------------------------------
	-- player advantage
	if hpdp<hpdt
		then gHUDPvsT_bar_width_hpdp = (hpdt-hpdp)*gHUDPvsT_bar_width
				--player hp offset
				gHUDPvsT_HP_BAR:ClearAllPoints()
				gHUDPvsT_HP_BAR:SetPoint("LEFT", "gHUDPvsT_HP_FRAME", "CENTER", 0, 0)
				gHUDPvsT_HP_BAR:SetWidth(gHUDPvsT_bar_width_hpdp)
	end
	---------------------------------------------------------
	if hpdp==hpdt
		then gHUDPvsT_bar_width_hpdp = 1
				gHUDPvsT_bar_width_hpdt = 1
				--reset hp offset
				gHUDPvsT_HP_BAR:ClearAllPoints()
				gHUDPvsT_HP_BAR:SetPoint("LEFT", "gHUDPvsT_HP_FRAME", "CENTER", 0, 0)
				gHUDPvsT_HP_BAR:SetWidth(gHUDPvsT_bar_width_hpdp)
				gHUDPvsT_HP_BAR:SetWidth(gHUDPvsT_bar_width_hpdt)
	end
	end
	---------------------------------------------------------
	--color function
	gHUDPvsT_health_color()
end
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
--playervstarget MP
	function gHUDPvsT_MP_OnEvent()
	--texture
	gHUDPvsT_textures()

	gHUDPvsT_BAR_TEXTURE_W_MP:SetTexture(gHUD_TEXTURE_B_w)
	gHUDPvsT_BACKGROUND_TEXTURE_W_MP:SetTexture(gHUD_TEXTURE_BG_w)

	gHUDPvsT_MP_BAR:SetHeight(gHUDPvsT_bar_height)
	gHUDPvsT_MP_FRAME:SetHeight(gHUDPvsT_bar_height)

	gHUDPvsT_MP_FRAME:SetWidth(gHUDPvsT_bar_width*2)

	--set mp anchor
	gHUDPvsT_MP_FRAME:SetPoint("TOP", "gHUDPvsT_HP_FRAME", "BOTTOM", 0, -2)
	---------------------------------------------------------
	--deficit value function
	gHUDPvsT_deficit_values()
	---------------------------------------------------------
	--mp pvst
	-- target advantage
	if UnitIsVisible("target")==1 then
		if UnitPowerType("target")==0 then
			if mpdp>mpdt then 
				gHUDPvsT_bar_width_mpdt = (mpdp-mpdt)*gHUDPvsT_bar_width
				--target mp offset
				gHUDPvsT_MP_BAR:ClearAllPoints()
				gHUDPvsT_MP_BAR:SetPoint("LEFT", "gHUDPvsT_MP_FRAME", "CENTER", -gHUDPvsT_bar_width_mpdt, 0)
				gHUDPvsT_MP_BAR:SetWidth(gHUDPvsT_bar_width_mpdt)
			end
			---------------------------------------------------------
			-- player advantage
			if mpdp<mpdt
				then gHUDPvsT_bar_width_mpdp = (mpdt-mpdp)*gHUDPvsT_bar_width
						--player mp offset
						gHUDPvsT_MP_BAR:ClearAllPoints()
						gHUDPvsT_MP_BAR:SetPoint("LEFT", "gHUDPvsT_MP_FRAME", "CENTER", 0, 0)
						gHUDPvsT_MP_BAR:SetWidth(gHUDPvsT_bar_width_mpdp)
			end
			---------------------------------------------------------
			if mpdp==mpdt
				then gHUDPvsT_bar_width_mpdp = 1
						gHUDPvsT_bar_width_mpdt = 1
						--reset mp offset
						gHUDPvsT_MP_BAR:ClearAllPoints()
						gHUDPvsT_MP_BAR:SetPoint("LEFT", "gHUDPvsT_MP_FRAME", "CENTER", 0, 0)
						gHUDPvsT_MP_BAR:SetWidth(gHUDPvsT_bar_width_mpdp)
						gHUDPvsT_MP_BAR:SetWidth(gHUDPvsT_bar_width_mpdt)

			end
			---------------------------------------------------------
		else
			if UnitPowerType("target")~=0 or UnitExists("target")==nil or UnitIsDead("target")==true or UnitIsGhost("target")==true
			then
				gHUDPvsT_bar_width_mpdp = 1
				gHUDPvsT_bar_width_mpdt = 1
				
				--reset mp offset
				gHUDPvsT_MP_BAR:ClearAllPoints()
				gHUDPvsT_MP_BAR:SetPoint("LEFT", "gHUDPvsT_MP_FRAME", "CENTER", 0, 0)
				gHUDPvsT_MP_BAR:SetWidth(gHUDPvsT_bar_width_mpdp)
				gHUDPvsT_MP_BAR:SetWidth(gHUDPvsT_bar_width_mpdt)
			end
		end
	end
	---------------------------------------------------------
	--color function
	gHUDPvsT_mana_color()
	---------------------------------------------------------

end
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
function gHUDPvsT_health_color()
	--deficit value function
	gHUDPvsT_deficit_values()
	---------------------------------------------------------
	---------------------------------------------------------
	 -- player advantage
	if (hpdp<hpdt) then
		local hp_deficit_p = (hpdt - hpdp)
	---------------------------------------------------------
	-- 0
		if (hp_deficit_p) == (pvst_hp_med_color_value) then 
			gHUDPvsT_BAR_TEXTURE_W_HP:SetVertexColor(gHUDPvsT_hp_color.pvst_hp_color_50_r, gHUDPvsT_hp_color.pvst_hp_color_50_g, gHUDPvsT_hp_color.pvst_hp_color_50_b, gHUDPvsT_hp_color.pvst_hp_color_50_a)
			gHUDPvsT_BACKGROUND_TEXTURE_W_HP:SetVertexColor(gHUDPvsT_hp_color.pvst_hp_color_50_r, gHUDPvsT_hp_color.pvst_hp_color_50_g, gHUDPvsT_hp_color.pvst_hp_color_50_b, gHUDPvsT_hp_color.pvst_hp_color_50_a)
			end
	---------------------------------------------------------
	-- >0
		if (hp_deficit_p) > (pvst_hp_med_color_value) then 
			gHUDPvsT_BAR_TEXTURE_W_HP:SetVertexColor(1-hp_deficit_p, gHUDPvsT_hp_color.pvst_hp_color_50_g, gHUDPvsT_hp_color.pvst_hp_color_50_b, gHUDPvsT_hp_color.pvst_hp_color_50_a)
			gHUDPvsT_BACKGROUND_TEXTURE_W_HP:SetVertexColor(1-hp_deficit_p, gHUDPvsT_hp_color.pvst_hp_color_50_g, gHUDPvsT_hp_color.pvst_hp_color_50_b, gHUDPvsT_hp_color.pvst_hp_color_50_a)
		end
	end
	---------------------------------------------------------
	---------------------------------------------------------
	-- target advantage
	if (hpdp>hpdt) then
		local hp_deficit_t = (hpdp - hpdt)
	---------------------------------------------------------
		if (hp_deficit_t) == (pvst_hp_med_color_value) then
			gHUDPvsT_BAR_TEXTURE_W_HP:SetVertexColor(gHUDPvsT_hp_color.pvst_hp_color_50_r, gHUDPvsT_hp_color.pvst_hp_color_50_g, gHUDPvsT_hp_color.pvst_hp_color_50_b, gHUDPvsT_hp_color.pvst_hp_color_50_a)
			gHUDPvsT_BACKGROUND_TEXTURE_W_HP:SetVertexColor(gHUDPvsT_hp_color.pvst_hp_color_50_r, gHUDPvsT_hp_color.pvst_hp_color_50_g, gHUDPvsT_hp_color.pvst_hp_color_50_b, gHUDPvsT_hp_color.pvst_hp_color_50_a)
		end
	---------------------------------------------------------
		if (hp_deficit_t) > (pvst_hp_med_color_value) then
			gHUDPvsT_BAR_TEXTURE_W_HP:SetVertexColor(gHUDPvsT_hp_color.pvst_hp_color_00_r, 1-hp_deficit_t, gHUDPvsT_hp_color.pvst_hp_color_00_b, gHUDPvsT_hp_color.pvst_hp_color_00_a)
			gHUDPvsT_BACKGROUND_TEXTURE_W_HP:SetVertexColor(gHUDPvsT_hp_color.pvst_hp_color_00_r, 1-hp_deficit_t, gHUDPvsT_hp_color.pvst_hp_color_00_b, gHUDPvsT_hp_color.pvst_hp_color_00_a)
		end
	end
end
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------
function gHUDPvsT_mana_color()
	--deficit value function
	gHUDPvsT_deficit_values()
	---------------------------------------------------------
	---------------------------------------------------------
	 -- player advantage
	if UnitPowerType("target")==0 then
		if (mpdp<mpdt) then
			local mp_deficit_p = (mpdt - mpdp)
		---------------------------------------------------------
		-- 0
			if (mp_deficit_p) == (pvst_mp_med_color_value) then 
				gHUDPvsT_BAR_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_50_r, gHUDPvsT_mp_color.pvst_mp_color_50_g, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
				gHUDPvsT_BACKGROUND_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_50_r, gHUDPvsT_mp_color.pvst_mp_color_50_g, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
				end
		---------------------------------------------------------
		-- >0
			if (mp_deficit_p) > (pvst_mp_med_color_value) then 
				gHUDPvsT_BAR_TEXTURE_W_MP:SetVertexColor(1-mp_deficit_p, 1-mp_deficit_p, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
				gHUDPvsT_BACKGROUND_TEXTURE_W_MP:SetVertexColor(1-mp_deficit_p, 1-mp_deficit_p, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
			end
		end
		---------------------------------------------------------
		---------------------------------------------------------
		-- target advantage
		if (mpdp>mpdt) then
			local mp_deficit_t = (mpdp - mpdt)
		---------------------------------------------------------
			if (mp_deficit_t) == (pvst_mp_med_color_value) then
				gHUDPvsT_BAR_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_50_r, gHUDPvsT_mp_color.pvst_mp_color_50_g, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
				gHUDPvsT_BACKGROUND_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_50_r, gHUDPvsT_mp_color.pvst_mp_color_50_g, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
			end
		---------------------------------------------------------
			if (mp_deficit_t) > (pvst_mp_med_color_value) then
				gHUDPvsT_BAR_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_00_r, 1-mp_deficit_t, 1-mp_deficit_t, gHUDPvsT_mp_color.pvst_mp_color_00_a)
				gHUDPvsT_BACKGROUND_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_00_r, 1-mp_deficit_t, 1-mp_deficit_t, gHUDPvsT_mp_color.pvst_mp_color_00_a)
			end
		end
	---------------------------------------------------------
		else 
			gHUDPvsT_BAR_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_50_r, gHUDPvsT_mp_color.pvst_mp_color_50_g, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
			gHUDPvsT_BACKGROUND_TEXTURE_W_MP:SetVertexColor(gHUDPvsT_mp_color.pvst_mp_color_50_r, gHUDPvsT_mp_color.pvst_mp_color_50_g, gHUDPvsT_mp_color.pvst_mp_color_50_b, gHUDPvsT_mp_color.pvst_mp_color_50_a)
	end
end


