defaults = {
	["name"]		= "gHUDPvsT",
	["version"]		= "10001",
	["author"]		= "Mahiro/Grognaz Aegwynn(EU)",
}
options = {
	["lock"]	= 0,
	["debug"]	= 0,
	["standby"]	= 0,
	["posX"]	= nil,
	["posY"]	= nil,
}

--slash commands 
function gHUDPvsT_Command(cmd)
--list 

if (cmd=="")
	then DEFAULT_CHAT_FRAME:AddMessage("Groggy HUD PvsT Commands:")
			DEFAULT_CHAT_FRAME:AddMessage("lock")
			DEFAULT_CHAT_FRAME:AddMessage("reset")
			DEFAULT_CHAT_FRAME:AddMessage("debug")
end
---------------------------------------------------------
--lock
if (cmd=="lock") then
	if (options.lock==0) then
		options.lock=1
		gHUDPvsT_HP_FRAME:SetMovable(false)
		gHUDPvsT_HP_FRAME:EnableMouse(false)
		gHUDPvsT_MP_FRAME:EnableMouse(false)
	
		options.posX = gHUDPvsT_HP_FRAME:GetLeft()
		options.posY = gHUDPvsT_HP_FRAME:GetBottom()
				
		gHUDPvsT_HP_FRAME:ClearAllPoints()
		gHUDPvsT_HP_FRAME:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", options.posX, options.posY)
					
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00gHUD_PvsT: locked" )
		if (options.debug==1) then
			DEFAULT_CHAT_FRAME:AddMessage("X: " .. options.posX )	
			DEFAULT_CHAT_FRAME:AddMessage("Y: " .. options.posY )
		end
		if UnitExists("target")==false then
			gHUDPvsT_HP_FRAME:Hide()
			gHUDPvsT_MP_FRAME:Hide()
		end
	else
		options.lock=0
		gHUDPvsT_HP_FRAME:Show()
		gHUDPvsT_MP_FRAME:Show()
				
		gHUDPvsT_HP_FRAME:SetMovable(true)
		gHUDPvsT_HP_FRAME:EnableMouse(true)
		
		options.posX = gHUDPvsT_HP_FRAME:GetBottom()
		options.posY = gHUDPvsT_HP_FRAME:GetLeft()	
				
		gHUDPvsT_HP_FRAME:GetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", options.posX, options.posY)
				
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00gHUD_PvsT: unlocked" )
		if (options.debug==1) then	
			DEFAULT_CHAT_FRAME:AddMessage("X: " .. options.posX )	
			DEFAULT_CHAT_FRAME:AddMessage("Y: " .. options.posY )
		end
	end
end
---------------------------------------------------------
--reset
	if (cmd=="reset") then
		options.posX = 0
		options.posY = 0
		gHUDPvsT_HP_FRAME:ClearAllPoints()
		gHUDPvsT_HP_FRAME:SetPoint("CENTER", nil, "CENTER", options.posX, options.posY)
	end
---------------------------------------------------------
--debug
	if (cmd=="debug") then
		if (options.debug==1) then
			options.debug=0
			DEFAULT_CHAT_FRAME:AddMessage("debug: " ..options.debug)
		else options.debug=1
			DEFAULT_CHAT_FRAME:AddMessage("debug: " ..options.debug)
		end
	end
end
------------------------------------------------------------------------------------------------------------------
 --mouse up
function gHUDPvsT_OnMouseUp()
	if (gHUDPvsT_HP_FRAME.isMoving) then
		gHUDPvsT_HP_FRAME:StopMovingOrSizing()
		gHUDPvsT_HP_FRAME.isMoving = false
		
		options.posX = gHUDPvsT_HP_FRAME:GetLeft()
		options.posY = gHUDPvsT_HP_FRAME:GetBottom()
		gHUDPvsT_HP_FRAME:ClearAllPoints()
		gHUDPvsT_HP_FRAME:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", options.posX, options.posY)
			--DEFAULT_CHAT_FRAME:AddMessage("X: " .. options.posX )	
			--DEFAULT_CHAT_FRAME:AddMessage("Y: " .. options.posY )
	end
end

--mouse down
function gHUDPvsT_OnMouseDown()
	if (gHUDPvsT_HP_FRAME:IsMovable()) then	
		if  ((not gHUDPvsT_HP_FRAME.isLocked) or (gHUDPvsT_HP_FRAME.isLocked == 0) and (arg1 == "LeftButton")) then
			gHUDPvsT_HP_FRAME:StartMoving()
			gHUDPvsT_HP_FRAME.isMoving = true
		end
	end
end
